
#property copyright "Copyright  2008"
#property link      "itemsdepot@hotmail.com"
//
//+------------------------------------------------------------------+
//|                                                                  |
//| 2008 Updated to 4 Timeframe display     ( itemsdepot@hotmail.com)|
//| Multi301 Version2b     Code Excerpts from BasketBars Indicator   |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 4 

#property indicator_color1 Green
#property indicator_color2 MediumSeaGreen
#property indicator_color3 Lime
#property indicator_color4 White

#property indicator_width1 7
#property indicator_width2 7
#property indicator_width3 4
#property indicator_width4 2

extern int     MUDrawRange=1000;
extern bool    MUAudioAlert=False;
extern bool    MUCyclePairs=True;
extern int     MUCycleDelay=25;
extern bool    MUDraw1M=True;
extern bool    MUDraw5M=True;
extern bool    MUDraw15M=True;
extern bool    MUDraw30M=True;

extern string  MUPair= "EURUSD";
extern string  MUPair1  = "USDJPY";
extern string  MUPair2  = "GBPUSD";
extern string  MUPair3  = "USDCHF";
extern string  MUPair4  = "USDCAD";
extern string  MUPair5  = "AUDUSD";
extern string  MUPair6  = "NZDUSD";

extern double  MUTime;
extern int     MUCounter=1;

int            Tperiod1 = 30;
int            Tperiod2 = 15;
int            Tperiod3 = 5;
int            Tperiod4 = 1;

//---------------

double Period1[];
double Period2[];
double Period3[];
double Period4[];
double Chart[5];
bool MUCycleFlag=False;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
    IndicatorShortName("Multi301 R2b");
  
    SetIndexBuffer(0,Period1);
    if (MUDraw30M==True) SetIndexStyle(0,DRAW_HISTOGRAM ,0,indicator_width1,indicator_color1);
     else SetIndexStyle(0,12,0,indicator_width1,indicator_color1);
    //SetIndexArrow(0, 110); 
    SetIndexLabel(0,"Thirty Minute 30M "); 
    //-------------------------------------- 
    if (MUDraw30M==False && MUDraw15M==True)
    {    
    SetIndexBuffer(1,Period2);
    if (MUDraw15M==True) SetIndexStyle(1,DRAW_HISTOGRAM,0,indicator_width1,indicator_color1);
     else SetIndexStyle(1,12,0,indicator_width1,indicator_color1);
    //SetIndexArrow(1, 119);
    SetIndexLabel(1,"Fifteen Minute 15M ");       
    //--------------------------------------   
    }else{
    SetIndexBuffer(1,Period2);
    if (MUDraw15M==True) SetIndexStyle(1,DRAW_LINE,0,indicator_width2,indicator_color2);
     else SetIndexStyle(1,12,0,indicator_width2,indicator_color2);
    //SetIndexArrow(1, 119);
    SetIndexLabel(1,"Fifteen Minute 15M ");       
    //--------------------------------------    
    }    
    if (MUDraw30M==False && MUDraw15M==False)
    {     
    SetIndexBuffer(2,Period3);
    if (MUDraw5M==True) SetIndexStyle(2,DRAW_HISTOGRAM,0,indicator_width1,indicator_color1);
     else SetIndexStyle(2,12,0,indicator_width1,indicator_color1);
    //SetIndexArrow(2, 108);
    SetIndexLabel(2,"Five Minute 5M ");
    }else{   
    SetIndexBuffer(2,Period3);
    if (MUDraw5M==True) SetIndexStyle(2,DRAW_LINE,0,indicator_width3,indicator_color3);
     else SetIndexStyle(2,12,0,indicator_width3,indicator_color3);
    //SetIndexArrow(2, 108);
    SetIndexLabel(2,"Five Minute 5M ");        
    }    
    SetIndexBuffer(3,Period4);
    if (MUDraw1M==True) SetIndexStyle(3,DRAW_LINE,0,indicator_width4,indicator_color4);
     else SetIndexStyle(3,12,0,indicator_width4,indicator_color4);
    //SetIndexArrow(3,108);
    SetIndexLabel(3,"One Minute 1M ");
    //---------------------------------------
    MUTime=TimeLocal();
    //----
   return(0);
   }
  
  
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+


int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
   
  }
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
  
     int counted_bars=IndicatorCounted();
     int pos=MUDrawRange;
     double tf1,tf2,tf3,tf4,tf5,tf6,tf7,tf8;
     bool MUSpeak=False;
     double MUFinishTime=TimeLocal();
     MUCycleFlag=False;
     MUFinishTime=TimeLocal(); 
     MUSpeak=False;  
     if (MUCycleDelay<10) MUCycleDelay=10;
     //------------------------------------                                              
     if ((MUFinishTime - MUTime) >= MUCycleDelay )    // && pos==0)
       {       
           MUFinishTime=TimeLocal();
           MUTime=TimeLocal();
           MUCycleFlag=True;
           MUSpeak=True;           
       }  
     if ( MUCycleFlag==True )
     {
       //-------------------------------
       if (MUCounter==1) MUPair=MUPair1;  
       if (MUCounter==2) MUPair=MUPair2;
       if (MUCounter==3) MUPair=MUPair3;  
       if (MUCounter==4) MUPair=MUPair4;  
       if (MUCounter==5) MUPair=MUPair5;
       if (MUCounter==6) MUPair=MUPair6;
       
       //Print("Multi301V2 Currently Displaying "+MUPair);               
       MUCounter=MUCounter+1;                    
       if (MUCounter>6) MUCounter=1;         
     }    
     while (pos>=0)
      
      {
           
      tf1=(getbid(MUPair,Tperiod1,pos))/10000;
      Period1[pos] = tf1;
      if (pos==0) Chart[1]=tf1;
      //----------------           
      tf2=(getbid(MUPair,Tperiod2,pos))/10000;
      Period2[pos] = tf2;
      if (pos==0) Chart[2]=tf2;
      //----------------
      tf3=(getbid(MUPair,Tperiod3,pos))/10000;
      Period3[pos] = tf3;
      if (pos==0) Chart[3]=tf3;
      //----------------          
      tf4=(getbid(MUPair,Tperiod4,pos))/10000;
      Period4[pos] = tf4;
      //----------------
      if (pos==0) Chart[4]=tf4;

      pos--; 
     
      }    

     ObjectDelete("Label1");
     ObjectDelete("Chart4");
     ObjectDelete("Chart3");
     ObjectDelete("Chart2");
     ObjectDelete("Chart1");
      
     //------------------------------------------------
     if(!ObjectCreate("Label1", OBJ_LABEL, 4, 0, 0))
       {
        Print("Multi301 Error: Can't create Label1 - Code #",GetLastError());
       return(0);
       }else{
         ObjectSetText("Label1",MUPair ,24, "Tahoma");
         ObjectSet("Label1", OBJPROP_COLOR, Lime);
	    //ObjectSet("Label1", OBJPROP_BACK, Green);
	      ObjectSet("Label1", OBJPROP_XDISTANCE, 15);
         ObjectSet("Label1", OBJPROP_YDISTANCE, 15); 
       }  
         
     if(!ObjectCreate("Chart4", OBJ_LABEL, 4, 0, 0))
       {
        Print("Multi301 Error: Can't create Chart4 - Code #",GetLastError());
       return(0);
       }else{
         ObjectSetText("Chart4","01M: "+Chart[4] ,14, "Tahoma");
         if ( Chart[4] > Chart[3])
         { 
         ObjectSet("Chart4", OBJPROP_COLOR, Yellow);
         if ( MUSpeak==True ) PlaySound("chartposition.wav");
         }else{
         ObjectSet("Chart4", OBJPROP_COLOR, White);
         }        
	      //ObjectSet("Chart4", OBJPROP_BACK, Blue);
	      ObjectSet("Chart4", OBJPROP_XDISTANCE, 15);
         ObjectSet("Chart4", OBJPROP_YDISTANCE, 50); 
       }  

     if(!ObjectCreate("Chart3", OBJ_LABEL, 4, 0, 0))
       {
        Print("Multi301 Error: Can't create Chart3 - Code #",GetLastError());
       return(0);
       }else{
         ObjectSetText("Chart3","05M: "+Chart[3] ,14, "Tahoma");
         if ( Chart[3] > Chart[2])
         { 
         ObjectSet("Chart3", OBJPROP_COLOR, Yellow);
         if ( MUSpeak==True ) PlaySound("chartposition.wav");
         }else{
         ObjectSet("Chart3", OBJPROP_COLOR, White);
         }
	    //ObjectSet("Chart3", OBJPROP_BACK, Green);
	      ObjectSet("Chart3", OBJPROP_XDISTANCE, 15);
         ObjectSet("Chart3", OBJPROP_YDISTANCE, 70); 
       }  
         
     if(!ObjectCreate("Chart2", OBJ_LABEL, 4, 0, 0))
       {
        Print("Multi301 Error: Can't create Chart2 - Code #",GetLastError());
       return(0);
       }else{
         ObjectSetText("Chart2","15M: "+Chart[2] ,14, "Tahoma");
         if ( Chart[2] > Chart[1])
         { 
         ObjectSet("Chart2", OBJPROP_COLOR, Yellow);
         if ( MUSpeak==True ) PlaySound("chartposition.wav");
         }else{
         ObjectSet("Chart2", OBJPROP_COLOR, White);
         }
	    //ObjectSet("Chart2", OBJPROP_BACK, Green);
	      ObjectSet("Chart2", OBJPROP_XDISTANCE, 15);
         ObjectSet("Chart2", OBJPROP_YDISTANCE, 90); 
       }  

     if(!ObjectCreate("Chart1", OBJ_LABEL, 4, 0, 0))
       {
        Print("Multi301 Error: Can't create Chart1 - Code #",GetLastError());
       return(0);
       }else{
         ObjectSetText("Chart1","30M: "+Chart[1] ,14, "Tahoma");
         ObjectSet("Chart1", OBJPROP_COLOR, White);
	    //ObjectSet("Chart1", OBJPROP_BACK, Green);
	      ObjectSet("Chart1", OBJPROP_XDISTANCE, 15);
         ObjectSet("Chart1", OBJPROP_YDISTANCE, 110); 
       }  
   return(0);
  }
  
//+------------------------------------------------------------------+
 
double getbid(string c,int tf, int ni)
   {
      double   cbid = iOpen(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(cbid);
   }                   
   
   